﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace pr164_2
{
    // Абстрактный класс: 
    abstract class Base
    {
        // Защищенные целочисленные поля: 
        protected int num1;
        protected int num2;
        // Конструктор с двумя аргументами: 
        public Base(int n1, int n2)
        {
            num1 = n1;
            num2 = n2;
        }
        // Абстрактный индексатор с целочисленным индексом: 
        public abstract int this[int k]
        {
            get;
        }
    }

    // Интерфейс: 
    interface MyInterface
    {
        // Объявление метода: 
        int setNum(int n);
    }

    // Производный класс наследует абстрактный базовый класс 
    // и реализует интерфейс: 
    class MyClass : Base, MyInterface
    {
        // Конструктор с двумя аргументами: 
        public MyClass(int n1, int n2) : base(n1, n2) { }
        // Явная реализация индексатора из 
        // абстрактного класса: 
        public override int this[int k]
        {
            get
            {
                if (k % 2 == 0)
                    return num1;
                else
                    return num2;
            }
        }
        // Описание метода из интерфейса: 
        public int setNum(int n)
        {
            return n * (num1 + num2);
        }
    }

    class Program
    {
        static void Main()
        {
            // Создание объекта:
            MyClass obj = new MyClass(2, 5);
            // Вызов индексатора:
            Console.WriteLine("obj[1] = " + obj[1]);
            Console.WriteLine("obj[2] = " + obj[2]);
            Console.WriteLine("obj.setNum(3) = " + obj.setNum(3));
            // Задержка:
            Console.ReadLine();
        }
    }
}
